import cv2
import datetime
import sys, os

WIDTH: int = 320
HEIGHT: int = 240

#VideoCaptureオブジェクト取得
cap = cv2.VideoCapture(0)

cap.set(cv2.CAP_PROP_FRAME_WIDTH, WIDTH)
cap.set(cv2.CAP_PROP_FRAME_HEIGHT, HEIGHT)

avg = None


saikidou=0

wakukando=90
satueikando=80

usbmemorydir="C:"


photopath =  usbmemorydir + "\\photo\\"
if os.path.exists(photopath) :
    pass
else :
    os.mkdir(photopath)



#設定ファイル作成
cconf = usbmemorydir + '\\photo\\cconf.txt'
f = open(cconf,'w')
f.close()



#終了シグナルファイル作成
camerapyexit = usbmemorydir + '\\photo\\camerapyexit.txt'
f = open(camerapyexit,'w')
f.close()



#再起動シグナルファイル作成
camerapyreboot = usbmemorydir + '\\photo\\camerapyreboot.txt'
f = open(camerapyreboot,'w')
f.close()


#カメラストップ
camerastop = usbmemorydir + '\\photo\\camerastop.txt'
f = open(camerastop,'w')
f.write("0")
f.close()



#ログファイルいるかどうか？
logfiledir = usbmemorydir + '\\photo\\camerasystem.log'
if logfiledir:
    pass
else:
    f = open(logfiledir,'w')
    f.close()




print("---------------------------------")
print("Windows監視カメラシステムスタート")
print("実行ディレクトリ" + os.path.abspath(__file__))
print("---------------------------------")


if logfiledir:
    f = open(logfiledir,'a')
    f.write("---------------------------------\n")
    f.write("Windows監視カメラシステムスタート\n")
    f.write("実行ディレクトリ" + os.path.abspath(__file__) + "\n")
    f.write("---------------------------------\n")
    f.close()

try:

    while(True):
        
        #フレームを取得
        ret, frame = cap.read()
        #frame = cv2.rotate(frame, cv2.ROTATE_180)
        
        if not ret:
            print("---------------------------------")
            print("エラー発生したので再起動します。")
            print("---------------------------------")
            if logfiledir:
                f = open(logfiledir,'a')
                f.write("---------------------------------")
                f.write("エラー発生したので再起動します。")
                f.write("---------------------------------")
                f.close()


            cap.release()
            cv2.destroyAllWindows()
            os.execv(sys.executable, [sys.executable, 'camera.py'])



        #撮影テスト
        f = open(cconf,'r')
        testflg = f.read()
        f.close()
        if testflg == "1":
            if logfiledir:

                testPass =  usbmemorydir + "\\photo\\test"
                if os.path.exists(testPass) :
                    pass
                else :
                    os.mkdir(testPass)

                teststrdate=datetime.datetime.now().strftime('%Y%m%d%H%M%S%f')
                testfname=usbmemorydir + "\\photo\\test\\" + teststrdate + ".jpg"
                cv2.imwrite(testfname, frame)

                logdate=datetime.datetime.now().strftime('%Y/%m/%d %H:%M:%S')
                f = open(logfiledir,'a')
                f.write(logdate + " [Log]テストしました。\n")
                f.close()

                f = open(cconf,'w')
                f.write("0")
                f.close()



        #終了シグナル
        f = open(camerapyexit,'r')
        endflg = f.read()
        f.close()
        if endflg == "1":
            if logfiledir:
                logdate=datetime.datetime.now().strftime('%Y/%m/%d %H:%M:%S')
                f = open(logfiledir,'a')
                f.write(logdate + " [Log]プログラム終了操作を行いました。\n")
                f.close()

                f = open(camerapyexit,'w')
                f.write("0")
                f.close()

                break


        #Python再起動シグナル
        f = open(camerapyreboot,'r')
        rebootflg = f.read()
        f.close()
        if rebootflg == "1":
            if logfiledir:
                logdate=datetime.datetime.now().strftime('%Y/%m/%d %H:%M:%S')
                f = open(logfiledir,'a')
                f.write(logdate + " [Log]プログラム再起動操作を行いました。\n")
                f.close()

                f = open(camerapyreboot,'w')
                f.write("0")
                f.close()

                cap.release()
                cv2.destroyAllWindows()
                os.execv(sys.executable, [sys.executable, 'camera.py'])



        #日付作成
        dirstrdate=datetime.datetime.now().strftime('%Y%m%d%H%M') 

        
        #Path作成
        path1 = usbmemorydir + "\\photo\\" + dirstrdate
        

        #動体検知処理
        #グレースケールに変換
        gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)

        # 比較用にフレームの切り出し保存
        if avg is None:
            avg = gray.copy().astype("float")
            continue

        #現在のフレームと移動平均との差を計算
        cv2.accumulateWeighted(gray, avg, 0.5)
        frameDelta = cv2.absdiff(gray, cv2.convertScaleAbs(avg))

        #画像を２値化する
        thresh = cv2.threshold(frameDelta, 3, 255, cv2.THRESH_BINARY)[1]

        #輪郭を抽出する
        contours = cv2.findContours(thresh, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)[0]

        strdate1=datetime.datetime.now().strftime('%Y/%m/%d %H:%M:%S') 
        cv2.putText(frame, strdate1, (225, 10), cv2.FONT_HERSHEY_PLAIN, 0.5, (0, 255, 0), 1, cv2.LINE_AA)

        # 差分があった点を画面に描く
        for target in contours:
            x, y, w, h = cv2.boundingRect(target)

            #夜は暗いので感度高めで
            kandojikan=datetime.datetime.now().strftime('%H') 
            #暗い時間の場合
            if kandojikan == 22 or kandojikan == 23 or kandojikan == 0 or kandojikan == 1 or kandojikan == 2 or kandojikan == 3 or kandojikan == 4 or kandojikan == 5 or kandojikan == 6 or kandojikan == 7:
                #暗い感度高め
                wakukando=110
                satueikando=110
            else :
                wakukando=120
                satueikando=120            

            if w < wakukando: continue #条件以下の変更点は除外

                #動体の位置を描画
            cv2.rectangle(frame, (x, y), (x + w, y + h), (0,255,0), 1)        
            
            #撮影制限のIF文
            if w > satueikando:

                if os.path.exists(path1) :
                    pass
                else :
                    os.mkdir(path1)

                strdate=datetime.datetime.now().strftime('%Y%m%d%H%M%S%f') 
                
                fname=usbmemorydir + "\\photo\\" + dirstrdate + "\\" + strdate + ".png"

                f = open(camerastop,'r')
                stopflg = f.read()
                f.close()
                if stopflg == "0":
                    cv2.imwrite(fname, frame)

        #画像表示
        cv2.imshow("Windows camera.py", frame)
        
        #キーボード入力処理
        key = cv2.waitKey(1)
        if key == 13: #enterキーの場合処理を抜ける
            print("Enter押したためシステム終了")
            break
            


except:
    print("---------------------------------")
    print("exceptエラー発生したので再起動します。")
    print("---------------------------------")
    cap.release()
    cv2.destroyAllWindows()
    os.execv(sys.executable, [sys.executable, 'camera.py'])

#カメラデバイスクローズ
cap.release()

#ウィンドウクローズ
cv2.destroyAllWindows()

